using System;
using System.Runtime.InteropServices;  // required for PInvoking

namespace HeartbeatDotNET
{
	/// <summary>
	/// Summary description for CEAPI.
	/// </summary>
	public class CEAPI
	{
		public const uint GENERIC_READ = 0x80000000;
		public const uint GENERIC_WRITE = 0x40000000;
		public const int OPEN_EXISTING = 3;
		public const int INVALID_HANDLE_VALUE = -1;

		[DllImport("coredll.dll", EntryPoint="WriteFile")]
		public static extern bool WriteFile(
			int hFile, 
			Byte[] lpBuffer, 
			int nNumberOfBytesToWrite, 
			ref int lpNumberOfBytesWritten, 
			int lpOverlapped);

		[DllImport("coredll.dll", EntryPoint="ReadFile")]
		private static extern bool ReadFile(
			int hFile,
			byte[] lpBuffer,
			int nNumberOfBytesToRead,
			ref int lpNumberOfBytesRead,
			int lpOverlapped);

		[DllImport("coredll.dll", EntryPoint="CreateFile")]
		public static extern int CreateFile(
			string lpFileName,
			uint dwDesiredAccess,
			int dwShareMode,
			int lpSecurityAttributes,
			int dwCreationDisposition,
			int dwFlagsAndAttributes,
			int hTemplateFile);

		[DllImport("coredll.dll", EntryPoint="CloseHandle")]
		public static extern bool CloseHandle(int hObject);

		[DllImport("coredll.dll", EntryPoint="GetLastError")]
		public static extern int GetLastError();
	}
}
